--- upgradepkg.orig	2009-09-06 22:16:09.000000000 +0100
+++ upgradepkg	2009-09-06 22:16:03.000000000 +0100
@@ -38,25 +38,8 @@
 # Return a package name that has been stripped of the dirname portion
 # and any of the valid extensions (only):
 pkgbase() {
-  PKGEXT=$(echo $1 | rev | cut -f 1 -d . | rev)
-  case $PKGEXT in
-  'tgz' )
-    PKGRETURN=$(basename $1 .tgz)
-    ;;
-  'tbz' )
-    PKGRETURN=$(basename $1 .tbz)
-    ;;
-  'tlz' )
-    PKGRETURN=$(basename $1 .tlz)
-    ;;
-  'txz' )
-    PKGRETURN=$(basename $1 .txz)
-    ;;
-  *)
-    PKGRETURN=$(basename $1)
-    ;;
-  esac
-  echo $PKGRETURN
+  # basename + strip extensions .tbz, .tgz, .tlz and .txz
+  echo "$1" | sed 's?.*/??;s/\.t[bglx]z$//'
 }
 
 usage() {
@@ -147,32 +130,8 @@
 # old package.
 
 package_name() {
-  STRING=$(pkgbase $1)
-  # Check for old style package name with one segment:
-  if [ "$(echo $STRING | cut -f 1 -d -)" = "$(echo $STRING | cut -f 2 -d -)" ]; then
-    echo $STRING
-  else # has more than one dash delimited segment
-    # Count number of segments:
-    INDEX=1
-    while [ ! "$(echo $STRING | cut -f $INDEX -d -)" = "" ]; do
-      INDEX=$(expr $INDEX + 1)
-    done
-    INDEX=$(expr $INDEX - 1) # don't include the null value
-    # If we don't have four segments, return the old-style (or out of spec) package name:
-    if [ "$INDEX" = "2" -o "$INDEX" = "3" ]; then
-      echo $STRING
-    else # we have four or more segments, so we'll consider this a new-style name:
-      NAME=$(expr $INDEX - 3)
-      NAME="$(echo $STRING | cut -f 1-$NAME -d -)"
-      echo $NAME
-      # cruft for later ;)
-      #VER=$(expr $INDEX - 2)
-      #VER="$(echo $STRING | cut -f $VER -d -)"
-      #ARCH=$(expr $INDEX - 1)
-      #ARCH="$(echo $STRING | cut -f $ARCH -d -)"
-      #BUILD="$(echo $STRING | cut -f $INDEX -d -)"
-    fi
-  fi
+  # Strip version, architecture and build from the end of the name
+  pkgbase $1 | sed 's?-[^-]*-[^-]*-[^-]*$??'
 }
 
 ERRCODE=0
